package routes

// |@@| C

import (
	"gardening/src/dat/maes"
	"gardening/src/lib/route"
	"gardening/src/mae"
	"gardening/src/srv/json_views"
	"github.com/gin-gonic/gin"
)

type ListPlantsApiRoute struct {
	ApiRoute           *route.ApiRoute
	ListPlantsJsonView *json_views.ListPlantsJsonView
	ListPlantsMae      *mae.ListPlantsMae
}

func (this *ListPlantsApiRoute) Act(c *gin.Context) {
	in := &maes.ListPlantsMaeIn{}
	this.ApiRoute.PopulateInContext(c, &in.Context)
	err := c.BindJSON(&in.Request)
	if err != nil {
		c.AbortWithError(401, err)
		return
	}
	out, errMae := this.ListPlantsMae.Act(c, in)
	if errMae != nil {
		panic(errMae)
	}
	json, err := this.ListPlantsJsonView.Json(out)
	if err != nil {
		panic(err)
	}
	c.Status(200)
	c.Writer.Write(json)
}
